class SMSCompress:
	def __init__(self, filename):
		f = open(filename, "r")

		# riempio un dizionario con parola e sua forma abbreviata
		self.dizionario = dict()
		#
		# la readline() legge il contenuto di un file una linea alla volta. 
		# Lascia il carattere di newline alla fine, pertanto dovro` toglierlo
		# a mano quando popolo il dizionario
		#
		linea = f.readline()
		
		while linea != '':
			parti = linea.split(' ')
			if len(parti) == 2:
				self.dizionario[parti[0]] = parti[1].replace("\n", "")
			linea = f.readline()

		# quando ho finito, chiudo il file
		f.close()

	
	def compress(self, filetesto):
		# leggo il testo dell'SMS originale
		fin = open(filetesto, "r")
		testo = fin.read()

		self.__lunghezza_testo_originale = len(testo)
		
		# chiudo il file!
		fin.close()

		for parola in self.dizionario.keys():
			testo = testo.replace(parola, self.dizionario[parola])

		self.__testo_compresso = testo


	def testoCompresso(self):
		return self.__testo_compresso

	def salva(self, nomefile_out):
		f = open(nomefile_out, "w")
		f.write(self.__testo_compresso)
		f.close() # non dimenticare!

	def compressione(self):
		return 100 * (self.__lunghezza_testo_originale - len(self.__testo_compresso)) / self.__lunghezza_testo_originale

	
